#!/usr/bin/python
# -*- coding: utf-8 -*-



import matplotlib.pyplot as plt
import utils as ut
import numpy as np

#Funcions per coordenades no calibrades
def epipolar_lines_im1(imatge_1, correspondencies, F):

    fig = plt.figure(figsize=(4, 5), dpi=100)
    im = plt.imread(imatge_1)
    implot = plt.imshow(im)

    for x,y in correspondencies:

        plt.plot(x[1],x[0],'*')    

        l = np.dot(ut.hom(y),F.T)
        p = np.array([x[0][1], x[0][0],1])
        graph('(-l[2]-x*l[0])/l[1]', range(0, foto.shape[1]))


    plt.show()
    return

def epipolar_lines_im2(imatge_2, correspondencies, F):

    fig = plt.figure(figsize=(4, 5), dpi=100)
    im = plt.imread(imatge_2)
    implot = plt.imshow(im)

    for x,y in correspondencies:

        plt.plot(y[1],y[0],'*')    

        l = np.dot(ut.hom(x),F)
        p = np.array([x[0][1], x[0][0],1])
        graph('(-l[2]-x*l[0])/l[1]', range(0, foto.shape[1]))


    plt.show()
    return

#Funcions per coordenades calibrades

def calibrated_lines_im1(imatge_1, x1, x2, K_1, K_2, F_):
    fig = plt.figure(figsize=(4, 5), dpi=100)
    im = plt.imread(imatge_1)
    implot = plt.imshow(im)

    for x in zip(x1,x2):

        a = K_1.dot(x[0])
        b = K_2.dot(x[1])
        plt.plot(a[0], a[1],'*')    
        l = np.dot(b,F_)
        graph('(-l[2]-x*l[0])/l[1]', range(0, len(im[0])))

    plt.show()
    
def calibrated_lines_im2(imatge_2, x1, x2, K_1, K_2, F_):
    fig = plt.figure(figsize=(4, 5), dpi=100)
    im = plt.imread(imatge_2)
    implot = plt.imshow(im)

    for x in zip(x1,x2):

        a = K_2.dot(x[1])
        b = K_1.dot(x[0])
        plt.plot(a[0], a[1],'*')    

        l = np.dot(b,F_)
        graph('(-l[2]-x*l[0])/l[1]', range(0, len(im[0])))

    plt.show()


def graph(formula, x_range):  
        x = np.array(x_range)  
        y = eval(formula)
        plt.plot(x, y)